package edu.uw.cameratest;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;

import android.app.Activity;
import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.hardware.Camera;
import android.hardware.Camera.Parameters;
import android.os.Bundle;
import android.os.Environment;
import android.util.Log;
import android.view.SurfaceHolder;
import android.view.SurfaceView;
import android.widget.ImageView;
import sparta.checkers.quals.*;

import  sparta.checkers.quals.Sink;
import  sparta.checkers.quals.Source;
import static sparta.checkers.quals.FlowPermission.*;


public class CameraTestActivity extends Activity implements SurfaceHolder.Callback
{
    //a variable to store a reference to the Image View at the main.xml file
    private @Sink(DISPLAY) ImageView iv_image;
    //a variable to store a reference to the Surface View at the main.xml file
    private @Sink(DISPLAY) SurfaceView sv;

    //a bitmap to display the captured image
    private @Source(CAMERA) Bitmap bmp;

    //Camera variables
    //a surface holder
    private   @Sink(DISPLAY)  SurfaceHolder sHolder;
    //a variable to control the camera
    private Camera mCamera;
    //the camera parameters
    private @Source(CAMERA_SETTINGS) Parameters parameters;

    /** Called when the activity is first created. */
	@Override
	protected void onCreate(@Source(ANY) Bundle savedInstanceState) {
		
		@SuppressWarnings("flow")//Bundles need a Qualifier Parameter 
		@Source(ANY) @Sink(ANY) Bundle b = savedInstanceState;
        super.onCreate(b);
       
        setContentView(R.layout.main);

        //get the Image View at the main.xml file
        @SuppressWarnings("flow")//Once stub files defaults the other "half" of the annotation correctly, this won't be needed
        @Sink(DISPLAY) ImageView tmp_iv_image = (ImageView) findViewById(R.id.imageView1);
        iv_image = tmp_iv_image ;

        //get the Surface View at the main.xml file
        @SuppressWarnings("flow")//Once stub files defaults the other "half" of the annotation correctly, this won't be needed
        @Sink(DISPLAY) SurfaceView tmp_sv = (SurfaceView) findViewById(R.id.surfaceView1);

        sv = tmp_sv;

        @SuppressWarnings("flow")//Once stub files defaults the other "half" of the annotation correctly, this won't be needed
        @Sink(DISPLAY) SurfaceHolder tmp_sHolder = sv.getHolder();
        //Get a surface
        sHolder = tmp_sHolder;

        //add the callback interface methods defined below as the Surface View callbacks
        sHolder.addCallback(this);

        //tells Android that this surface will have its data constantly replaced
        sHolder.setType(SurfaceHolder.SURFACE_TYPE_PUSH_BUFFERS);
    }


    public void surfaceChanged(SurfaceHolder arg0, int arg1, int arg2, int arg3)
    {
         //get camera parameters
         parameters = mCamera.getParameters();

         //set camera parameters
         mCamera.setParameters(parameters);
         mCamera.startPreview();
         final Context ctx = this;
         //sets what code should be executed after the picture is taken
         @SuppressWarnings("flow")//Can't figure out how to annotate the constructor
         Camera./*@Source(CAMERA)*/ /*@Sink(ANY)*/ PictureCallback mCall = new Camera.PictureCallback()
         {

        	 @Override
             public void onPictureTaken(@Source(CAMERA)  byte /*@Source(CAMERA)*/ [] data, @Source(CAMERA) Camera camera)
             {
            	 Log.w("test", "hi");
                 //decode the data obtained by the camera into a Bitmap
            	 
                 bmp = BitmapFactory.decodeByteArray(data, 0, data.length);
                 //set the iv_image
                 iv_image.setImageBitmap(bmp);
                 @SuppressWarnings("flow")//ByteArrayOutStream is annotated {}->ANY in the stubfile, but it is default to LITERAL->CONDTIONAL here
                 @Source(CAMERA) ByteArrayOutputStream bytes = new ByteArrayOutputStream();
                 bmp.compress(Bitmap.CompressFormat.JPEG, 40, bytes);
                 
                @Sink(FILESYSTEM)  @Source({FILESYSTEM, LITERAL}) 
                 String filename = ctx.getDir("log", Context.MODE_PRIVATE) + File.separator + "test.jpg";                 
                //you can create a new file name "test.jpg"
                 File f = new File(filename);
                 try {
					f.createNewFile();
					FileOutputStream fo = new FileOutputStream(f);
					@Source(CAMERA) byte [] ba = bytes.toByteArray();
	                fo.write(ba);
	                fo.close();
	                bytes.close();
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
                 //write the bytes in file
                 
             }
         };

         mCamera.takePicture(null, null, mCall);
    }

    @RequiredPermissions(android.Manifest.permission.CAMERA)
    public void surfaceCreated(@Sink(DISPLAY) @Source(CAMERA) SurfaceHolder holder)
    {
        // The Surface has been created, acquire the camera and tell it where
        // to draw the preview.
        mCamera = Camera.open();
        try {
           mCamera.setPreviewDisplay(holder);

        } catch (IOException exception) {
            mCamera.release();
            mCamera = null;
        }
    }

    
    public void surfaceDestroyed(SurfaceHolder holder)
    {
        //stop the preview
        mCamera.stopPreview();
        //release the camera
        mCamera.release();
        //unbind the camera from this object
        mCamera = null;
    }
}
