package android.hello;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Scanner;

import org.apache.http.NameValuePair;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.HttpClient;
import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.message.BasicNameValuePair;

import sparta.checkers.quals.FlowSinks;
import sparta.checkers.quals.FlowSources;
import sparta.checkers.quals.FlowSinks.FlowSink;
import sparta.checkers.quals.FlowSources.FlowSource;
import sparta.checkers.quals.PolyFlowSources;
import sparta.checkers.quals.RequiredPermissions;

import android.app.Activity;
import android.content.Context;
import android.hardware.Sensor;
import android.hardware.SensorEvent;
import android.hardware.SensorEventListener;
import android.hardware.SensorManager;
import android.hello.MachineLearner.State;
import android.os.AsyncTask;
import android.os.Bundle;
import android.os.Environment;
import android.util.FloatMath;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;
import android.widget.ToggleButton;

public class HelloWorldActivity extends Activity implements SensorEventListener {
	private static final int MAXWINDOWSIZE = 50;
	Button plus, minus;
	TextView tv,bumpTV;
	SensorManager sensormanager;
	private EditText filename, commentBox;
	private @SuppressWarnings("flow") @FlowSources(FlowSource.EXTERNAL_STORAGE) File externalStorageDirectory;
	private @SuppressWarnings("flow") @FlowSinks(FlowSink.EXTERNAL_STORAGE) @FlowSources FileWriter filewriter;
	private @SuppressWarnings("flow")@FlowSources(FlowSource.EXTERNAL_STORAGE) @FlowSinks FileReader filereader;
	private MachineLearner machinelearner;

	/** Called when the activity is first created. */
	@RequiredPermissions(android.Manifest.permission.INTERNET)
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.main);
		tv = (TextView) findViewById(R.id.textview);
		bumpTV = (TextView) findViewById(R.id.textView1);
		filename = (EditText) findViewById(R.id.filename);
		commentBox = (EditText) findViewById(R.id.commentBox);
		tv.setText("hello");
		sensormanager = (SensorManager) getSystemService(SENSOR_SERVICE);
		externalStorageDirectory = Environment.getExternalStorageDirectory();
		BumpTrainToggleButton = (ToggleButton) findViewById(R.id.BumpTrainToggle);
		BumpTestToggleButton = (ToggleButton) findViewById(R.id.BumpTestToggle);
		machinelearner = new MachineLearner();

	}

	public void showFile(View view) {
		try {
			@SuppressWarnings("flow") //OK to read from file
            @FlowSources(FlowSource.EXTERNAL_STORAGE) 
			@FlowSinks File f = new File(externalStorageDirectory,filename.getText().toString());
			filereader = new FileReader(f);
			
			@SuppressWarnings("flow") //OK to read from file
			@FlowSources(FlowSource.EXTERNAL_STORAGE) Scanner scan;
			scan = new Scanner(filereader);
			@SuppressWarnings("flow") @FlowSources(FlowSource.EXTERNAL_STORAGE) String str = "";
			while (scan.hasNext()) {
				str += scan.nextLine() + "\n";
			}
			tv.setText(str);
		} catch (FileNotFoundException e1) {
			tv.setText("File Not Found");
			e1.printStackTrace();
		}
	}

	public void deleteFile(View view) {
		//Warning suppressed since this variable is only used to delete the file; no info flow. 
      @SuppressWarnings("flow") @FlowSources(FlowSource.EXTERNAL_STORAGE) File toDelete = new File(externalStorageDirectory, filename.getText()
				.toString());
      @SuppressWarnings("flow") @FlowSources @FlowSinks boolean temp = toDelete.exists() == false;
		  if (temp) {
			tv.setText("File Not Found");
		} else {
			toDelete.delete();
			tv.setText("Deleted");
		}
	}

	public void putComment(View view) {
		
		
		String comment = commentBox.getText().toString();
		try {
			@SuppressWarnings("flow") 
			@FlowSinks(FlowSink.EXTERNAL_STORAGE) 
			@FlowSources File f = new File(externalStorageDirectory,
					filename.getText().toString());
			filewriter = new FileWriter(f, true);
			@SuppressWarnings("flow") @FlowSinks(FlowSink.EXTERNAL_STORAGE) @FlowSources  String temp = "#" + comment + "\n";
			filewriter.write(temp);
			filewriter.flush();
			filewriter.close();
		} catch (IOException e) {
			tv.setText("Couldn't open file");
			e.printStackTrace();
		}

	}

	public void ls(View view) {
		File file[] = externalStorageDirectory.listFiles();
		String str = "";
		for (int i = 0; i < file.length; i++) {
			String filename = file[i].getName();
			str += filename + "\n";
		}
		tv.setText(str);
	}

	public void onAccuracyChanged(Sensor sensor, int accuracy) {
		// TODO Auto-generated method stub

	}

	public void onSensorChanged(SensorEvent event) {
		if (event.sensor.getType() == Sensor.TYPE_ACCELEROMETER) {
			String towrite = "%" + event.values[0] + " " + event.values[1]
					+ " " + event.values[2] + "\n";
			tv.setText(towrite);
			if (BumpTraining) {
				Float Z = event.values[2];
				CurWindow.add(Z);
				if (CurWindow.size() >= MAXWINDOWSIZE) {
					@FlowSources(FlowSource.ACCELEROMETER) Float std = standardDeviationCalculate(CurWindow);
					bumpFeat.add(std);
					CurWindow = new ArrayList<Float>();
				}
			} else if (BumpTesting) {
				Float Z = event.values[2];
				CurWindow.add(Z);
				if (CurWindow.size() >= MAXWINDOWSIZE) {
					Float std = standardDeviationCalculate(CurWindow);
					MachineLearner.State st = machinelearner.BumpClassify(std);
					if(st==State.Bump)
					{
						numBumps++;
						SimpleDateFormat dateFormat = new SimpleDateFormat("MM/dd/yyyy HH:mm:ss");
						Date date = new Date();
						bumpTV.setText("Bump Detected at "+dateFormat.format(date)+"\n" +
								numBumps+" bumps found so far");
						logToServer(dateFormat.format(date)+" Bump");
					}
					CurWindow = new ArrayList<Float>();
				}
				
			}
			
			else {


			}
		} 
		else if (event.sensor.getType() == Sensor.TYPE_GYROSCOPE) {
			String towrite = "$" + event.values[0] + " " + event.values[1]
					+ " " + event.values[2] + "\n";
			tv.setText(towrite);
			try {
				filewriter.write(towrite);
			} catch (IOException e) {
				tv.setText("Couldn't write to file");
			}
		}

	}

	private void logToServer(final String string) {
		new AsyncTask<String, Long, Integer>() {



			@Override
			protected Integer doInBackground(String... params) {
				HttpClient httpclient = new DefaultHttpClient();
			    HttpPost httppost = new HttpPost("http://homes.cs.washington.edu/~bhora/wolverine.php");

			    try {
			        // Add your data
			        List<NameValuePair> nameValuePairs = new ArrayList<NameValuePair>(2);
			        nameValuePairs.add(new BasicNameValuePair("str", string+"\n"));
			        httppost.setEntity(new UrlEncodedFormEntity(nameValuePairs));

			        // Execute HTTP Post Request
			        httpclient.execute(httppost);
			        
			    } catch (ClientProtocolException e) {
			        // TODO Auto-generated catch block
			    } catch (IOException e) {
			        // TODO Auto-generated catch block
			    }

			    return 0;
			}
		}.execute("Bump");

		
	}

	public @PolyFlowSources Float standardDeviationCalculate(@PolyFlowSources List<Float> data) {
		int n = data.size();
		if (n < 2) {
			return Float.NaN;
		}
		Float avg = data.get(0);
		float sum = 0;
		for (int i = 1; i < data.size(); i++) {
			Float newavg = avg + (data.get(i) - avg) / (i + 1);
			sum += (data.get(i) - avg) * (data.get(i) - newavg);
			avg = newavg;
		}
		// Change to ( n - 1 ) to n if you have complete data instead of a
		// sample.
		return FloatMath.sqrt(sum / (n - 1));
	}
	
	public Float amplitudeCalculate(List<Float> data){
		if(data.size()<=0)
		{
			return Float.NaN;
		}
		Float min = Float.MAX_VALUE;
		Float max = Float.MIN_NORMAL;
		for(Float element:data)
		{
			if(element<min)
				min=element;
			if(element>max)
				max=element;
		}
		return max-min;
	}

	@SuppressWarnings("flow") //The warnings are not interesting
	@FlowSources(FlowSource.ACCELEROMETER) List<Float> CurWindow;
	@SuppressWarnings("flow") //The warnings are not interesting
	@FlowSources(FlowSource.ACCELEROMETER) List< Float> bumpFeat;
	Boolean BumpTraining = false, BumpTesting = false;
	ToggleButton BumpTrainToggleButton, BumpTestToggleButton;
	int numBumps;

	public void BumpTrainToggle(View view) {
		Log.e("hi","HELLO!!");
		if (BumpTrainToggleButton.isChecked()) {
			if (bumpFeat == null) {
				bumpFeat = new ArrayList<Float>();
			}
			CurWindow = new ArrayList<Float>();
			BumpTraining = true;
			sensormanager.registerListener(this, sensormanager
					.getDefaultSensor(Sensor.TYPE_ACCELEROMETER),
					SensorManager.SENSOR_DELAY_GAME);

		} else {
			Log.e("TrainToggle", "Button pressed");
			BumpTraining = false;
			sensormanager.unregisterListener(this, sensormanager
					.getDefaultSensor(Sensor.TYPE_ACCELEROMETER));
			Log.e("TrainToggle", "Success");

		}
	}

	public void BumpTrainReset(View view) {
		bumpFeat = new ArrayList<Float>();
		CurWindow = new ArrayList<Float>();

	}

	public void BumpTrain(View view) {
		float thresh = machinelearner.BumpTrain(bumpFeat);
		bumpTV.setText("Bump Threshold set to " + thresh);

	}

	public void BumpTestToggle(View view) {
		if (BumpTestToggleButton.isChecked()) {
			CurWindow = new ArrayList<Float>();
			numBumps=0;
			BumpTesting = true;
			sensormanager.registerListener(this, sensormanager
					.getDefaultSensor(Sensor.TYPE_ACCELEROMETER),
					SensorManager.SENSOR_DELAY_GAME);

		} else {
			BumpTesting = false;
			sensormanager.unregisterListener(this, sensormanager
					.getDefaultSensor(Sensor.TYPE_ACCELEROMETER));

		}
	}
}